﻿using System;
using System.Collections.Generic;

namespace readonly_value_ref
{
    class Program
    {
        readonly StructPerson sarah = new StructPerson() { Name = "Kerrigan", Age = 27 };
        readonly ClassPerson james = new ClassPerson() { Name = "Raynor", Age = 30 };

        static void Main(string[] args)
        {
            Program pg = new Program();
            pg.Test();

            var roe = new ReadOnlyEnumerator(new List<int> { 1, 2 });
            roe.PrintTheFirstElement(); // 출력 결과: 0  
        }

        private void Test()
        {
            sarah.IncAge();
            james.IncAge();

            //sarah.Age = 32;
            //james.Age = 32;

            Console.WriteLine("sarah age: " + sarah.Age); // 28
            Console.WriteLine("james age: " + james.Age); // 31
        }
    }

    struct StructPerson
    {
        public int Age;
        public string Name;

        public void IncAge()
        {
            Age++;
        }
    }

    class ClassPerson
    {
        public int Age;
        public string Name;

        public void IncAge()
        {
            Age++;
        }
    }

    internal class ReadOnlyEnumerator
    {
        private readonly List<int>.Enumerator _enumerator;

        public ReadOnlyEnumerator(List<int> list)
        {
            _enumerator = list.GetEnumerator();
        }

        public void PrintTheFirstElement()
        {
            _enumerator.MoveNext();
            Console.WriteLine(_enumerator.Current);
        }
    }
}
